; Turbo Assembler program STARS v1.10
; by SeaD

Ideal
P286
Model	TINY
Assume	cs:CODE, ds:CODE

Include 'service.inc'

Stack	00100h

Segment CODE
  Random DW 0ED38h,033CFh,04F60h,05BC6h,0491Ah,04C8Fh,0FAE8h,04445h,\
	    0C96Eh,0C79Ah,04D62h,03452h,04D2Bh,03EC6h,045B5h,023D6h,\
	    05DE8h,04A59h,0B2EAh,09A5Ch,057C2h,09F6Dh,01B66h,0FBAAh,\
	    0B28Eh,09119h,07F4Ch,018CFh,097BCh,08AB8h,05218h,0C79Bh
  timer_Random DW ?
  Start:
	push  cs
	pop   ds
	GraphVmode
	mov   ax,00004h
	xor   cx,cx
	xor   dx,dx
	int   Mouse_Int

	call Put_Stars

	mov   dx,Pal_Register_Mask
	mov   al,0BFh
	out   dx,al
	mov   ah,080h
Lop1:
	push  ax

	call  Roll_Palette
	call  Wait_Retrace

	mov   ax,00003h
	int   Mouse_Int
	pop   ax
	inc   ah
	and   ah,al
	and   bx,00007h
	jnz   S Exit
	and   cx,cx
	jnz   S Exit
	and   dx,dx
	jnz   S Exit
	push  ax
	mov   ah,006h
	mov   dl,0FFh
	int   Dos_Int
	pop   ax
	jz    Lop1

Exit:
	DosVmode
	ExitToDos

Proc	Roll_Palette
	mov   bx,03F00h
	mov   cx,00020h
LopPal:
	mov   dx,Pal_Register_WR
	mov   al,ah
	out   dx,al
	mov   dx,Pal_Data
	mov   al,bl
	out   dx,al
	out   dx,al
	out   dx,al
	xor   ah,020h
	mov   dx,Pal_Register_WR
	mov   al,ah
	out   dx,al
	mov   dx,Pal_Data
	mov   al,bh
	out   dx,al
	out   dx,al
	out   dx,al
	xor   ah,020h
	add   bl,002h
	sub   bh,002h
	inc   ah
	and   ah,0BFh
	loop  LopPal
	ret
EndP

Proc	Put_Stars
	xor   ax,ax
	mov   es,ax
	mov   ax,[es:Timer_OFF]
	mov   [timer_Random],ax
	push  Screen_Buffer_SEG
	pop   es
	mov   si,OFFSET Random
	mov   dx,00080h
	mov   cx,000180h
LopStars:
	call  Random_Gen
	mov   [es:di],dl
	add   dx,00307h
	and   dx,01FBFh
	loop  lopStars
	ret
EndP

Proc	Random_Gen
	mov   bl,dh
	xor   bh,bh
	mov   di,[si+bx]
	mov   ax,[timer_Random]
	xor   al,cl
	xor   al,ch
	xor   ah,cl
	xor   ah,ch
	xor   di,ax
	cmp   di,Screen_Size320x200
	jb    SHORT LblRand
	and   di,Screen_Size320x200 - 001h
LblRand:
	ret
EndP

Proc	Wait_Retrace
	mov   cx,00070h
LopRetr:
	WaitRetrace
	loop  LopRetr
	ret
EndP

EndS

End	Start
